
-- Versuche einen String in eine Variable vom Typ Int zu parsen:
x= read "10" :: Int

-- Jetzt geben wir das doppelte aus:
putStrLn (show $ 2*x)

-- Dasselbe mit einem unparsierbaren String gibt eine Fehler:
y= read "Foo" :: Int
putStrLn (show $ 2*y)
-- *** Exception: Prelude.read: no parse

-- Den Fehler können wir fangen (aber nur im IO-Monaden):
import Control.Exception
putStrLn (show $ 2*y) `catch` (\ (ErrorCall _)-> putStrLn "Sorry.")

-- Mit x passiert das erwartete:
putStrLn (show $ 2*x) `catch` (\ (ErrorCall _)-> putStrLn "Sorry.")

-- Warum definieren wir nicht eine "sichere" read-Funktion?
readint x = return (read x) `catch` (\ (ErrorCall _)-> return (0::Int))

-- Scheint zu funktionieren:
a= readint "10"
b= readint "Foo"
-- aber oh weh:
a
b 
-- *** Exception: Prelude.read: no parse
-- Problem: `read x` wird erst ausgewertet (und die Exception kann erst gefangen
-- werden), wenn `b` ausgegeben werden soll.
-- Deshalb müssen wir in `readint` die Auswertung von `read x` forcieren:
readint' x = (return $! read x) `catch` (\ (ErrorCall _)-> return (0::Int))

-- `($!) :: (a-> b)-> a-> b` forciert die Auswertung des Arguments und wendet 
--   erst dann die Funktion an. 
-- Jetzt geht es:
b= readint' "Foo"
b